---
variables:
  TARGETOS: "linux"
  TARGETARCH: "amd64"
  GO_TARGET_OS: linux
  GO_CI_LINT_ARGS: "--timeout=10m -E gosec,goimports ./..."
  # renovate: datasource=docker
  GO_CI_LINT_IMAGE: golangci/golangci-lint:v1.64.6-alpine
  GO_SBOM_OPTS: ""
  # renovate: datasource=docker
  GO_IMAGE: golang:1.24
  CGO_ENABLED: 0
  GO_TEST_FLAGS: >-
    -mod=readonly
    -v
  OPERATOR_NAMESPACE: heat-operator-system
  OPERATOR_DEPLOYMENT: heat-operator-controller-manager
  TBC_SBOM_MODE: always

include:
  - project: 'renovate-bot/renovate-runner'
    ref: v20.1.0
    file: '/templates/renovate-config-validator.gitlab-ci.yml'
    rules:
      - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
        changes:
          paths:
            - .gitlab-ci.yml
            - renovate.json
  - project: 'sylva-projects/sylva-elements/renovate'
    ref: 1.0.0
    file: '/templates/renovate-dry-run.gitlab-ci.yml'
    rules:
      - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
        changes:
          paths:
            - renovate.json
  - project: 'sylva-projects/sylva-elements/ci-tooling/ci-templates'
    ref: 1.0.38
    file:
      - 'templates/docker-build.yml'
      - 'templates/operator-template.yml'
      - 'templates/release-notes.yml'
  - project: "to-be-continuous/gitleaks"
    ref: 2.7.0
    file: "templates/gitlab-ci-gitleaks.yml"
  - project: 'to-be-continuous/golang'
    ref: '4.12.1'
    file: '/templates/gitlab-ci-golang.yml'

# Allow go-govulncheck job to failed, as we don't want to block MR to be merged due to new CVEs
go-govulncheck:
  allow_failure: true
# Current to-be-continuous templates can not test operators. See https://gitlab.com/to-be-continuous/golang/-/issues/40
# Actual tests are provided by further jobs (test-operator)
go-build-test:
  rules:
    - when: never
# To be removed once operator tests are available
test-operator:
  rules:
    - when: never


yamllint:
  stage: test
  image: registry.gitlab.com/sylva-projects/sylva-elements/container-images/ci-image:v1.1.1
  needs: []
  script:
    - 'yamllint . -c .gitlab/ci/configuration/yamllint.yaml'
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    - if: '$CI_PIPELINE_SOURCE == "pipeline"'
